



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>线程池ThreadPoolExecutor与阻塞队列BlockingQueue应用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">线程池ThreadPoolExecutor与阻塞队列BlockingQueue应用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 07:34:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>作者QQ：1095737364 &nbsp; &nbsp;QQ群：123300273 &nbsp; &nbsp; 欢迎加入！</p>
<h2>1.线程池介绍</h2>
<div>　　JDK5.0以上: java.util.concurrent.ThreadPoolExecutor&nbsp;</div>
<div>构造函数签名:</div>
<div>
<div>
<pre class="prettyprint linenums">public ThreadPoolExecutor(<br />
    int corePoolSize,<br />
    int maximumPoolSize,<br />
    long keepAliveTime,<br />
    TimeUnit unit,<br />
    BlockingQueue&lt;Runnable&gt; workQueue,<br />
    RejectedExecutionHandler handler<br />
);   </pre>
</div>
</div>
<div>参数介绍:</div>
<div><strong>corePoolSize</strong>&nbsp;核心线程数，指保留的线程池大小（不超过maximumPoolSize值时，线程池中最多有corePoolSize 个线程工作）。&nbsp;</div>
<div><strong>maximumPoolSize</strong>&nbsp;指的是线程池的最大大小（线程池中最大有corePoolSize 个线程可运行）。&nbsp;</div>
<div><strong>keepAliveTime</strong>&nbsp;指的是空闲线程结束的超时时间（当一个线程不工作时，过keepAliveTime 长时间将停止该线程）。&nbsp;</div>
<div><strong>unit&nbsp;</strong>是一个枚举，表示 keepAliveTime 的单位（有NANOSECONDS, MICROSECONDS, MILLISECONDS, SECONDS, MINUTES, HOURS, DAYS，7个可选值）。&nbsp;</div>
<div><strong>workQueue</strong>&nbsp;表示存放任务的队列（存放需要被线程池执行的线程队列）。&nbsp;</div>
<div><strong>handler</strong>&nbsp;拒绝策略（添加任务失败后如何处理该任务）.</div>
<h2>2.运行策略</h2>
<div>1、线程池刚创建时，里面没有一个线程。任务队列是作为参数传进来的。不过，就算队列里面有任务，线程池也不会马上执行它们。</div>
<div>2、当调用 execute() 方法添加一个任务时，线程池会做如下判断：</div>
<div>&nbsp; &nbsp; a. 如果正在运行的线程数量小于 corePoolSize，那么马上创建线程运行这个任务；</div>
<div>&nbsp; &nbsp; b. 如果正在运行的线程数量大于或等于 corePoolSize，那么将这个任务放入队列。</div>
<div>&nbsp; &nbsp; c. 如果这时候队列满了，而且正在运行的线程数量小于 maximumPoolSize，那么还是要创建线程运行这个任务；</div>
<div>&nbsp; &nbsp; d. 如果队列满了，而且正在运行的线程数量大于或等于 maximumPoolSize，那么线程池会抛出异常，告诉调用者&ldquo;我不能再接受任务了&rdquo;。</div>
<div>3、当一个线程完成任务时，它会从队列中取下一个任务来执行。</div>
<div>4、当一个线程无事可做，超过一定的时间（keepAliveTime）时，线程池会判断，如果当前运行 的线程数大于 corePoolSize，那么这个线程就被停掉。所以线程池的所有任务完成后，它最终会收缩到 corePoolSize 的大小。</div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp; &nbsp; &nbsp;这个过程说明，并不是先加入任务就一定会先执行。假设队列大小为 4，corePoolSize为2，maximumPoolSize为6，那么当加入15个任务时，执行的顺序类似这样：首先执行任务 1、2，然后任务3~6被放入队列。这时候队列满了，任务7、8、9、10 会被马上执行，而任务 11~15 则会抛出异常。最终顺序是：1、2、7、8、9、10、3、4、5、6。当然这个过程是针对指定大小的ArrayBlockingQueue&lt;Runnable&gt;来说，如果是LinkedBlockingQueue&lt;Runnable&gt;，因为该队列无大小限制，所以不存在上述问题。</div>
<h2>3.测试示例</h2>
<h3>(1)LinkedBlockingQueue&lt;Runnable&gt;队列使用1：</h3>
<div>
<div>
<pre class="prettyprint linenums">package threadQueueTest;<br />
import java.util.concurrent.BlockingQueue;<br />
import java.util.concurrent.LinkedBlockingQueue;<br />
import java.util.concurrent.ThreadPoolExecutor;<br />
import java.util.concurrent.TimeUnit;<br />
/**<br />
* User: 杨永生<br />
* Date: 15:47 2017/8/8<br />
* Email: kevin@hiibook.com<br />
*/<br />
public class ThreadPoolTest implements Runnable {<br />
    public void run() {<br />
    　　synchronized(this) {<br />
   　　 　　try{<br />
  　　  　　　　System.out.println(Thread.currentThread().getName());<br />
  　　 　　　　 Thread.sleep(3000);<br />
  　　 　　 }catch (InterruptedException e){<br />
   　　　　　　 e.printStackTrace();<br />
   　　　　 }<br />
  　　  }<br />
    }

    public static void main(String[] args) {<br />
   　　 BlockingQueue&lt;Runnable&gt; queue = new LinkedBlockingQueue&lt;Runnable&gt;();<br />
    　　ThreadPoolExecutor executor = new ThreadPoolExecutor(2, 6, 1, TimeUnit.DAYS, queue);<br />
    　　for (int i = 0; i &lt; 10; i++) {<br />
   　　　　 executor.execute(new Thread(new ThreadPoolTest(),"TestThread".concat(""+i)));<br />
    　　　　int threadSize = queue.size();<br />
    　　　　System.out.println("线程队列大小为--&gt;"+threadSize);<br />
    　　}<br />
   　　 executor.shutdown();<br />
    }<br />
}</pre>
</div>
</div>
<div>结果:</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;1</div>
<div>线程队列大小为--&gt;2</div>
<div>线程队列大小为--&gt;3</div>
<div>线程队列大小为--&gt;4</div>
<div>线程队列大小为--&gt;5</div>
<div>线程队列大小为--&gt;6</div>
<div>线程队列大小为--&gt;7</div>
<div>线程队列大小为--&gt;8</div>
<div>pool-1-thread-2</div>
<div>pool-1-thread-1</div>
<div>pool-1-thread-2</div>
<div>pool-1-thread-1</div>
<div>pool-1-thread-2</div>
<div>pool-1-thread-1</div>
<div>pool-1-thread-2</div>
<div>pool-1-thread-1</div>
<div>pool-1-thread-2</div>
<div>pool-1-thread-1</div>
<div>&nbsp;</div>
<div><strong>说明</strong>:可见，线程队列最大为8，共执行了10个线线程。因为是从线程池里运行的线程，所以虽然将线程的名称设为"TestThread".concat(""+i)，但输出后还是变成了pool-1-thread-x。</div>
<div>&nbsp;</div>
<h3>(2)LinkedBlockingQueue&lt;Runnable&gt;队列使用2：</h3>
<div>
<div>
<pre class="prettyprint linenums">package threadQueueTest;<br />
import java.util.concurrent.BlockingQueue;<br />
import java.util.concurrent.ArrayBlockingQueue;<br />
import java.util.concurrent.ThreadPoolExecutor;<br />
import java.util.concurrent.TimeUnit;<br />
/**<br />
* User: 杨永生<br />
* Date: 15:55 2017/8/8<br />
* Email: kevin@hiibook.com<br />
*/<br />
public class ThreadPoolTest2 implements Runnable {<br />
　　public void run() {<br />
　　　　synchronized(this) {<br />
　　　　　　try{<br />
　　　　　　　　System.out.println("线程名称："+Thread.currentThread().getName());<br />
　　　　　　　　Thread.sleep(3000); //休眠是为了让该线程不至于执行完毕后从线程池里释放<br />
　　　　　　}catch (InterruptedException e){<br />
　　　　　　　　e.printStackTrace();<br />
　　　　　　}<br />
　　　　}<br />
　　}

public static void main(String[] args) throws InterruptedException {<br />
　　BlockingQueue&lt;Runnable&gt; queue = new ArrayBlockingQueue&lt;Runnable&gt;(4); //固定为4的线程队列<br />
　　ThreadPoolExecutor executor = new ThreadPoolExecutor(2, 6, 1, TimeUnit.DAYS, queue);<br />
　　for (int i = 0; i &lt; 10; i++) {<br />
　　　　executor.execute(new Thread(new ThreadPoolTest2(), "TestThread".concat(""+i)));<br />
　　　　int threadSize = queue.size();<br />
　　　　System.out.println("线程队列大小为--&gt;"+threadSize);<br />
　　}<br />
　　executor.shutdown();<br />
　　}<br />
}</pre>
</div>
</div>
<div>结果:</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;1</div>
<div>线程队列大小为--&gt;2</div>
<div>线程队列大小为--&gt;3</div>
<div>线程队列大小为--&gt;4</div>
<div>线程队列大小为--&gt;4</div>
<div>线程队列大小为--&gt;4</div>
<div>线程队列大小为--&gt;4</div>
<div>线程队列大小为--&gt;4</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-4</div>
<div>线程名称：pool-1-thread-6</div>
<div>线程名称：pool-1-thread-1</div>
<div>线程名称：pool-1-thread-3</div>
<div>线程名称：pool-1-thread-5</div>
<div>线程名称：pool-1-thread-4</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-6</div>
<div>线程名称：pool-1-thread-1</div>
<div>&nbsp;</div>
<div><strong>说明</strong>: 可见，总共10个线程，因为核心线程数为2，2个线程被立即运行，线程队列大小为4，所以4个线程被加入队列，最大线程数为6，还能运行6-2=4个，其10个线程的其余4个线程又立即运行了。</div>
<div>&nbsp;</div>
<h3>(3)LinkedBlockingQueue&lt;Runnable&gt;队列使用3(测试异常)：</h3>
<div>如果将我们要运行的线程数10改为11，则由于最大线程数6+线程队列大小4=10&lt;11，则根据线程池工作原则，最后一个线程将被拒绝策略拒绝,将示例二的main方法改为如下</div>
<div>
<div>
<pre class="prettyprint linenums">public static void main(String[] args) throws InterruptedException {<br />
　　BlockingQueue&lt;Runnable&gt; queue = new ArrayBlockingQueue&lt;Runnable&gt;(4); //固定为4的线程队列<br />
　　ThreadPoolExecutor executor = new ThreadPoolExecutor(2, 6, 1, TimeUnit.DAYS, queue);<br />
　　for (int i = 0; i &lt; <strong>11</strong>; i++) {<br />
　　　　executor.execute(new Thread(new ThreadPoolTest2(), "TestThread".concat(""+i)));<br />
　　　　int threadSize = queue.size();<br />
　　　　System.out.println("线程队列大小为--&gt;"+threadSize);<br />
　　}<br />
　　executor.shutdown();<br />
}</pre>
</div>
</div>
<div>&nbsp;</div>
<div>结果:</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;1</div>
<div>线程队列大小为--&gt;2</div>
<div>线程队列大小为--&gt;3</div>
<div>线程队列大小为--&gt;4</div>
<div>线程队列大小为--&gt;4</div>
<div>线程队列大小为--&gt;4</div>
<div>线程队列大小为--&gt;4</div>
<div>线程队列大小为--&gt;4</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-4</div>
<div>线程名称：pool-1-thread-6</div>
<div>Exception in thread "main" java.util.concurrent.RejectedExecutionException: Task Thread[TestThread10,5,main] rejected from java.util.concurrent.ThreadPoolExecutor@21588809[Running, pool size = 6, active threads = 6, queued tasks = 4, completed tasks = 0]</div>
<div>at java.util.concurrent.ThreadPoolExecutor$AbortPolicy.rejectedExecution(ThreadPoolExecutor.java:2047)</div>
<div>at java.util.concurrent.ThreadPoolExecutor.reject(ThreadPoolExecutor.java:823)</div>
<div>at java.util.concurrent.ThreadPoolExecutor.execute(ThreadPoolExecutor.java:1369)</div>
<div>at threadQueueTest.ThreadPoolTest2.main(ThreadPoolTest2.java:27)</div>
<div>线程名称：pool-1-thread-1</div>
<div>线程名称：pool-1-thread-3</div>
<div>线程名称：pool-1-thread-5</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-4</div>
<div>线程名称：pool-1-thread-6</div>
<div>线程名称：pool-1-thread-1</div>
<div>&nbsp;</div>
<div><strong>说明</strong>:很明显，抛RejectedExecutionException异常了，被拒绝策略拒绝了，这就说明线程超出了线程池的总容量（线程队列大小+最大线程数）。</div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp;对于&nbsp;java.util.concurrent.BlockingQueue&nbsp;类有有三种方法将线程添加到线程队列里面，然而如何区别三种方法的不同呢，其实在队列未满的情况下结果相同，都是将线程添加到线程队列里面，区分就在于当线程队列已经满的时候，此时</div>
<div><strong>public boolean add(E e)</strong> 方法将抛出IllegalStateException异常，说明队列已满。</div>
<div><strong>public boolean offer(E e)</strong> 方法则不会抛异常，只会返回boolean值，告诉你添加成功与否，队列已满，当然返回false。</div>
<div><strong>public void put(E e) throws InterruptedException</strong> 方法则一直阻塞（即等待，直到线程池中有线程运行完毕，可以加入队列为止）。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<h3>(4)LinkedBlockingQueue&lt;Runnable&gt;队列使用3(测试add(E e)异常)：</h3>
<div>将示例二的main方法改为如下:</div>
<div>
<div>
<pre class="prettyprint linenums">public static void main(String[] args) throws InterruptedException {<br />
　　BlockingQueue&lt;Runnable&gt; queue = new ArrayBlockingQueue&lt;Runnable&gt;(4); //固定为4的线程队列<br />
　　ThreadPoolExecutor executor = new ThreadPoolExecutor(2, 6, 1, TimeUnit.DAYS, queue);<br />
　　for (int i = 0; i &lt; 10; i++) {<br />
　　　　executor.execute(new Thread(new ThreadPoolTest4(), "TestThread".concat(""+i)));<br />
　　　　int threadSize = queue.size();<br />
　　　　System.out.println("线程队列大小为--&gt;"+threadSize);<br />
　　　　if (threadSize==4){<br />
　　　　　　queue.add(new Runnable() { //队列已满，抛异常<br />
　　　　　　  @Override<br />
　　　　　 　 public void run(){<br />
　　　　　 　　　System.out.println("我是新线程，看看能不能搭个车加进去！");

　　　　　　  }<br />
　　　　   });<br />
　　　　}<br />
　　}<br />
　　executor.shutdown();<br />
}</pre>
</div>
</div>
<div>结果:</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;1</div>
<div>线程队列大小为--&gt;2</div>
<div>线程队列大小为--&gt;3</div>
<div>线程队列大小为--&gt;4</div>
<div>Exception in thread "main" java.lang.IllegalStateException: Queue full</div>
<div>at java.util.AbstractQueue.add(AbstractQueue.java:98)</div>
<div>at java.util.concurrent.ArrayBlockingQueue.add(ArrayBlockingQueue.java:312)</div>
<div>at threadQueueTest.ThreadPoolTest4.main(ThreadPoolTest4.java:33)</div>
<div>at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)</div>
<div>at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)</div>
<div>at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)</div>
<div>at java.lang.reflect.Method.invoke(Method.java:498)</div>
<div>at com.intellij.rt.execution.application.AppMain.main(AppMain.java:147)</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-1</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-1</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-1</div>
<div>
<h3>(5)LinkedBlockingQueue&lt;Runnable&gt;队列使用3(测试 offer(E e)异常)：</h3>
</div>
<div>将示例二的main方法改为如下:</div>
<div>
<div>
<pre class="prettyprint linenums">public static void main(String[] args) throws InterruptedException {<br />
　　BlockingQueue&lt;Runnable&gt; queue = new ArrayBlockingQueue&lt;Runnable&gt;(4); //固定为4的线程队列<br />
　　ThreadPoolExecutor executor = new ThreadPoolExecutor(2, 6, 1, TimeUnit.DAYS, queue);<br />
　　for (int i = 0; i &lt; 10; i++) {<br />
　　　　executor.execute(new Thread(new ThreadPoolTest5(), "TestThread".concat(""+i)));<br />
　　　　int threadSize = queue.size();<br />
　　　　System.out.println("线程队列大小为--&gt;"+threadSize);<br />
　　　　if (threadSize==4){<br />
　　　　　　final boolean flag = queue.offer(new Runnable() {<br />
　　　　　　　　@Override<br />
　　　　　　　　public void run(){<br />
　　　　　　　　　　System.out.println("我是新线程，看看能不能搭个车加进去！");<br />
　　　　　　　　}<br />
　　　　　　});<br />
　　　　　　System.out.println("添加新线程标志为--&gt;"+flag);<br />
　　　　}<br />
　　}<br />
　　executor.shutdown();<br />
}</pre>
</div>
</div>
<div>结果:</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;1</div>
<div>线程队列大小为--&gt;2</div>
<div>线程队列大小为--&gt;3</div>
<div>线程队列大小为--&gt;4</div>
<div>添加新线程标志为--&gt;false</div>
<div>线程队列大小为--&gt;4</div>
<div>添加新线程标志为--&gt;false</div>
<div>线程队列大小为--&gt;4</div>
<div>添加新线程标志为--&gt;false</div>
<div>线程队列大小为--&gt;4</div>
<div>添加新线程标志为--&gt;false</div>
<div>线程队列大小为--&gt;4</div>
<div>添加新线程标志为--&gt;false</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-4</div>
<div>线程名称：pool-1-thread-6</div>
<div>线程名称：pool-1-thread-1</div>
<div>线程名称：pool-1-thread-3</div>
<div>线程名称：pool-1-thread-5</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-4</div>
<div>线程名称：pool-1-thread-6</div>
<div>线程名称：pool-1-thread-1</div>
<h3>(6)LinkedBlockingQueue&lt;Runnable&gt;队列使用3(测试put(E e)异常)：</h3>
<div>将示例二的main方法改为如下:</div>
<div>
<div>
<pre class="prettyprint linenums">public static void main(String[] args) throws InterruptedException {<br />
　　BlockingQueue&lt;Runnable&gt; queue = new ArrayBlockingQueue&lt;Runnable&gt;(4); //固定为4的线程队列<br />
　　ThreadPoolExecutor executor = new ThreadPoolExecutor(2, 6, 1, TimeUnit.DAYS, queue);<br />
　　for (int i = 0; i &lt; 10; i++) {<br />
　　　　executor.execute(new Thread(new ThreadPoolTest6(), "TestThread".concat(""+i)));<br />
　　　　int threadSize = queue.size();<br />
　　　　System.out.println("线程队列大小为--&gt;"+threadSize);<br />
　　　　if (threadSize==4){<br />
　　　　　　queue.put(new Runnable() {<br />
　　　　　　　　@Override<br />
　　　　　　　　public void run(){<br />
　　　　　　　　　　System.out.println("我是新线程，看看能不能搭个车加进去！");<br />
　　　　　　　　}<br />
　　　　　　});<br />
　　　　}<br />
　　}<br />
　　executor.shutdown();<br />
}</pre>
</div>
</div>
<div>结果:</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;0</div>
<div>线程队列大小为--&gt;1</div>
<div>线程队列大小为--&gt;2</div>
<div>线程队列大小为--&gt;3</div>
<div>线程队列大小为--&gt;4</div>
<div>线程名称：pool-1-thread-1</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程名称：pool-1-thread-1</div>
<div>线程队列大小为--&gt;4</div>
<div>线程名称：pool-1-thread-3</div>
<div>线程名称：pool-1-thread-2</div>
<div>线程队列大小为--&gt;4</div>
<div>线程名称：pool-1-thread-4</div>
<div>线程名称：pool-1-thread-1</div>
<div>线程名称：pool-1-thread-3</div>
<div>线程队列大小为--&gt;3</div>
<div>线程队列大小为--&gt;4</div>
<div>线程名称：pool-1-thread-5</div>
<div>我是新线程，看看能不能搭个车加进去！</div>
<div>我是新线程，看看能不能搭个车加进去！</div>
<div>我是新线程，看看能不能搭个车加进去！</div>
<div>线程名称：pool-1-thread-2</div>
<div>我是新线程，看看能不能搭个车加进去！</div>
<div>&nbsp;</div>
<div><strong>说明</strong>:很明显，尝试了四次才加进去，前面三次尝试添加，但由于线程sleep(3000)，所以没有执行完，线程队列一直处于满的状态，直到某个线程执行完，队列有空位，新线程才加进去，没空位之前一直阻塞（即等待），我能加进去为止。</div>
<div>&nbsp;</div>
<h2>4.总结:</h2>
<div>那么线程池的排除策略是什么样呢，一般按如下规律执行：</div>
<div>A. &nbsp;如果运行的线程少于 corePoolSize，则 Executor 始终首选添加新的线程，而不进行排队。</div>
<div>B. &nbsp;如果运行的线程等于或多于 corePoolSize，则 Executor 始终首选将请求加入队列，而不添加新的线程。</div>
<div>C. &nbsp;如果无法将请求加入队列，则创建新的线程，除非创建此线程超出 maximumPoolSize，在这种情况下，任务将被拒绝。</div>
<div>&nbsp;</div>
<div>总结：</div>
<div>1. 线程池可立即运行的最大线程数 即maximumPoolSize 参数。</div>
<div>2. 线程池能包含的最大线程数 =&nbsp;可立即运行的最大线程数 + 线程队列大小 (一部分立即运行，一部分装队列里等待)</div>
<div>3. 核心线程数可理解为建议值，即建议使用的线程数，或者依据CPU核数</div>
<div>4. add，offer，put三种添加线程到队列的方法只在队列满的时候有区别，add为抛异常，offer返回boolean值，put直到添加成功为止。</div>
<div>5.同理remove，poll， take三种移除队列中线程的方法只在队列为空的时候有区别， remove为抛异常，poll为返回boolean值， take等待直到有线程可以被移除。</div>
<div>看看下面这张图就清楚了：</div>
<div><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/588112/201708/588112-20170814064008240-1344041485.gif" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<p>版权声明： 本文有&nbsp;```...裥簞點 发表于&nbsp;<a href="https://www.bloghome.com.cn/" rel="external nofollow noreferrer">bloghome博客</a></p>
<p>转载声明： 可自由转载、引用，但需要属名作者且注明文章出处。</p>
<p>文章链接：&nbsp;<a href="https://www.bloghome.com.cn/user/yysblog" rel="external nofollow noreferrer">https://www.bloghome.com.cn/user/yysblog</a></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxd2pe9.html">基于zookeeper实现统一资源管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn5wj3q.html">Asp&period;net有关GridView的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z6k3dq.html">使用my exclipse对数据库进行操作&lpar;4&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96z6j3q.html">Thoughts on an Article from Science &amp;&num;39&semi;A network framework of cultural history&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zw2gx8.html">RxJava操作符之Share&comma; Publish&comma; Refcount</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k3506q.html">directX基础学习系列7 网格（自己创建）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1e3vz9.html">rsync 远程数据同步工具详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmer1k9.html">winform中treeview中节点选中的技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z13r719.html">Geodesic-based robust blind watermarking method for three-dimensional mesh animation by using mesh segmentation and vertex trajectory</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmp7j69.html">ArcEngine查询、添加、删除要素的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xlw2v8.html">div垂直居中的方法（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj6y2d9.html">Object-C &mdash; KVO &amp;amp&semi; oc通知</a>
		</li>
						<li><a href="https://www.batexi.com/a/96on7jj9.html">&lbrack;MCM&rsqb;2014年美赛MCM题目原文及翻译</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wp74vq.html">一个简单方法：构造xml的document，并将其转换为string</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y2n2n8.html">Linux - &sol;etc&sol;passwd和&sol;etc&sol;shadow文件结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkvzvj8.html">SVN和Git 介绍&comma;区别&comma;优缺点以及适用范围</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj7vxr8.html">php生出随机字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gxx10q.html">Groovy学习笔记-实现接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvjjdk8.html">&period;yaml参数文件的编写和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdd5rv9.html">新手入门：目前为止最透彻的的Netty高性能原理和框架架构解析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7zdmz19.html">ASP&period;NET Core 源码学习之 Options&lbrack;4&rsqb;&colon;IOptionsMonitor</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mymyo8.html">AngularJs学习笔记1&mdash;&mdash;总体介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkykje8.html">for循环语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j35wx8.html">Ionic Demo 解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pd0mj8.html">C&num;窗体多语言切换（简繁）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzlmz08.html">day4作业小代码练习</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zdp339.html">EBS系统启动&amp;amp&semi;停止&amp;amp&semi;增加表空间&amp;amp&semi;替换首页图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1ke7oq.html">&lbrack;图形学&rsqb; Chp10 OpenGL三维观察程序示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1g412q.html">hdoj 1251 字典树&vert;&vert;map</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjw0dl8.html">Execution failed for task&amp;&num;39&semi;&colon;app&semi;clean&amp;&num;39&semi;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
